Index: code/branches/lod/src/orxonox/Level.cc
===================================================================
--- code/branches/lod/src/orxonox/Level.cc	(revision 6837)
+++ code/branches/lod/src/orxonox/Level.cc	(revision 6838)
@@ -126,5 +126,5 @@
         this->objects_.push_back(object);
         object->setGametype(this->getGametype());
-	object->setLevel(this);
+    object->setLevel(this);
     }
 
@@ -144,12 +144,12 @@
     void Level::addLodInfo(MeshLodInformation* lodInformation)
     {
-//		std::pair<std::map<std::string,MeshLodInformation*>::iterator,bool> it 
-//		    = new std::pair<lodInformation->getMeshName(),lodInformation>;
-		std::string meshName = lodInformation->getMeshName();
+//        std::pair<std::map<std::string,MeshLodInformation*>::iterator,bool> it 
+//            = new std::pair<lodInformation->getMeshName(),lodInformation>;
+        std::string meshName = lodInformation->getMeshName();
         this->lodInformation_.insert(std::make_pair(meshName,lodInformation));
-		//this->lodInformation_[std::make_pair<meshName,lodInformation>);
+        //this->lodInformation_[std::make_pair<meshName,lodInformation>);
     }
 
-    const MeshLodInformation* Level::getLodInfo(std::string meshName) const
+    MeshLodInformation* Level::getLodInfo(std::string meshName) const
     {
         if(this->lodInformation_.find(meshName)!=this->lodInformation_.end())
Index: code/branches/lod/src/orxonox/Level.h
===================================================================
--- code/branches/lod/src/orxonox/Level.h	(revision 6837)
+++ code/branches/lod/src/orxonox/Level.h	(revision 6838)
@@ -57,4 +57,7 @@
             void playerEntered(PlayerInfo* player);
             void playerLeft(PlayerInfo* player);
+			
+            MeshLodInformation* getLodInfo(std::string meshName) const;
+
 
         private:
@@ -63,5 +66,5 @@
 
             void addLodInfo(MeshLodInformation* object);
-            const MeshLodInformation* getLodInfo(std::string meshName) const;
+//            const MeshLodInformation* getLodInfo(std::string meshName) const;
 //            MeshLodInformation* getLodInfo(unsigned int index) const;
 
Index: code/branches/lod/src/orxonox/graphics/MeshLodInformation.h
===================================================================
--- code/branches/lod/src/orxonox/graphics/MeshLodInformation.h	(revision 6837)
+++ code/branches/lod/src/orxonox/graphics/MeshLodInformation.h	(revision 6838)
@@ -42,5 +42,4 @@
 		private:
 			void setLodLevel(unsigned int lodLevel);
-			int getLodLevel();
 			void setMeshSource(std::string meshSource);
 			std::string getMeshSource();
@@ -52,4 +51,5 @@
             virtual ~MeshLodInformation();
             
+			int getLodLevel();
             std::string getMeshName();
 
Index: code/branches/lod/src/orxonox/graphics/Model.cc
===================================================================
--- code/branches/lod/src/orxonox/graphics/Model.cc	(revision 6837)
+++ code/branches/lod/src/orxonox/graphics/Model.cc	(revision 6838)
@@ -29,5 +29,7 @@
 #include "Model.h"
 
-#include <OGRE/OgreEntity.h>
+// What's this? With the directory in front the filename, my compiler can't find the file...
+//#include <OGRE/OgreEntity.h>
+#include <OgreEntity.h>
 
 #include "core/CoreIncludes.h"
@@ -35,4 +37,6 @@
 #include "core/XMLPort.h"
 #include "Scene.h"
+#include "graphics/MeshLodInformation.h"
+#include "Level.h"
 
 namespace orxonox
@@ -58,8 +62,8 @@
     {
         SUPER(Model, XMLPort, xmlelement, mode);
-		
-		//LoD
+        
+        //LoD
         XMLPortParam(Model, "lodLevel", setLodLevel, getLodLevel, xmlelement, mode).defaultValues(5);
-		
+        
         XMLPortParam(Model, "mesh", setMeshSource, getMeshSource, xmlelement, mode);
         XMLPortParam(Model, "shadow", setCastShadows, getCastShadows, xmlelement, mode).defaultValues(true);
@@ -98,5 +102,11 @@
                     if(scale3d.z>scaleFactor)
                         scaleFactor = scale3d.z;
-
+                    
+                    Level* level_ = this->getLevel();
+                    
+                    MeshLodInformation* lodInfo = level_->getLodInfo(this->meshSrc_);
+                    if(lodInfo!=0)
+                        setLodLevel(lodInfo->getLodLevel());
+                    
                     COUT(0) << this->meshSrc_<< " lodLevel_: " << this->lodLevel_ <<" scale: "<< scaleFactor << std::endl;
                     //Fuer Asteroiden perfekt