Index: code/trunk/src/modules/objects/eventsystem/EventListener.cc
===================================================================
--- code/trunk/src/modules/objects/eventsystem/EventListener.cc	(revision 6855)
+++ code/trunk/src/modules/objects/eventsystem/EventListener.cc	(revision 6856)
@@ -62,7 +62,8 @@
         }
         
-        COUT(4) << "EventListener: Processing event: originator: " << event.originator_->getIdentifier()->getName() << " (&" << event.originator_ << ")" << ", activate: " << event.activate_ << ", name: " << event.name_ << std::endl;
+        COUT(4) << "EventListener, processing event: originator: " << event.originator_->getIdentifier()->getName() << " (&" << event.originator_ << ")" << ", activate: " << event.activate_ << ", name: " << event.name_ << std::endl;
 
         this->bActive_ = true;
+        //TODO: Why not this->fireEvent(event)?
         this->fireEvent(event.activate_, event.originator_, event.name_);
         this->bActive_ = false;
Index: code/trunk/src/modules/objects/triggers/MultiTriggerContainer.cc
===================================================================
--- code/trunk/src/modules/objects/triggers/MultiTriggerContainer.cc	(revision 6855)
+++ code/trunk/src/modules/objects/triggers/MultiTriggerContainer.cc	(revision 6856)
@@ -27,4 +27,9 @@
 */
 
+/**
+    @file MultiTriggerContainer.cc
+    @brief Implementation of the MultiTriggerContainer class.
+*/
+
 #include "MultiTriggerContainer.h"
 
@@ -33,19 +38,35 @@
 namespace orxonox
 {
-
-    CreateFactory(MultiTriggerContainer);
     
+    /**
+    @brief
+        Default constructor. Registers the object and creates an empty container.
+    @param creator
+        The creator.
+    */
     MultiTriggerContainer::MultiTriggerContainer(BaseObject* creator) : BaseObject(creator), originator_(NULL), data_(NULL)
     {
         RegisterObject(MultiTriggerContainer);
-        
     }
-    
+
+    /**
+    @brief
+        Constructor. Registers the object and sets the input values.
+    @param creator
+        The creator.
+    @param originator
+        A pointer to the originator of the Event, i.e. the MultiTrigger that fired the Event. (or is about to)
+    @param data
+        A pointer to the data that should be sent with the container.
+    */
     MultiTriggerContainer::MultiTriggerContainer(BaseObject* creator, MultiTrigger* originator, BaseObject* data) : BaseObject(creator), originator_(originator), data_(data)
     {
         RegisterObject(MultiTriggerContainer);
-        
     }
-    
+
+    /**
+    @brief
+        Destructor.
+    */
     MultiTriggerContainer::~MultiTriggerContainer()
     {
Index: code/trunk/src/modules/objects/triggers/MultiTriggerContainer.h
===================================================================
--- code/trunk/src/modules/objects/triggers/MultiTriggerContainer.h	(revision 6855)
+++ code/trunk/src/modules/objects/triggers/MultiTriggerContainer.h	(revision 6856)
@@ -21,8 +21,13 @@
  *
  *   Author:
- *      ...
+ *      Damian 'Mozork' Frick
  *   Co-authors:
  *      ...
  *
+*/
+
+/**
+    @file MultiTriggerContainer.h
+    @brief Definition of the MultiTriggerContainer class.
 */
 
@@ -37,20 +42,34 @@
 {
 
+    /**
+    @brief
+        This class is used by the MultiTrigger class to transport additional data via Events.
+    @author
+        Damian 'Mozork' Frick
+    */
     class _ObjectsExport MultiTriggerContainer : public BaseObject
     {
+        
         public:
-            
-            MultiTriggerContainer(BaseObject* creator);
-            MultiTriggerContainer(BaseObject* creator, MultiTrigger* originator, BaseObject* data);
-            ~MultiTriggerContainer();
-            
+            MultiTriggerContainer(BaseObject* creator); //!< Default constructor. Registers the object and creates an empty container.
+            MultiTriggerContainer(BaseObject* creator, MultiTrigger* originator, BaseObject* data); //!< Constructor. Registers the object and sets the input values.
+            ~MultiTriggerContainer(); //!< Destructor.
+
+            /**
+            @brief Get the originator of the Event. (The MultiTrigger that fired the Event)
+            @return Returns a pointer to the originator.
+            */
             inline MultiTrigger* getOriginator(void)
                 { return this->originator_; }
+            /**
+            @brief Get the data of this container.
+            @return Returns a pointer ot the data.
+            */
             inline BaseObject* getData(void)
                 { return this->data_; }
             
         private:
-            MultiTrigger* originator_;
-            BaseObject* data_;
+            MultiTrigger* originator_; //!< The originator.
+            BaseObject* data_; //!< The data.
     };
     