Index: code/branches/skybox2/src/libraries/core/Core.cc
===================================================================
--- code/branches/skybox2/src/libraries/core/Core.cc	(revision 6857)
+++ code/branches/skybox2/src/libraries/core/Core.cc	(revision 6858)
@@ -78,5 +78,4 @@
 
     SetCommandLineArgument(settingsFile, "orxonox.ini").information("THE configuration file");
-    SetCommandLineSwitch(noGametypeCaptions).information("Use this if you don't want to use Gametype captions.");
 
 #ifdef ORXONOX_PLATFORM_WINDOWS
@@ -150,10 +149,4 @@
         this->setConfigValues();
 
-        // no captions in gametype.
-        if(CommandLineParser::getValue("noGametypeCaptions").getBool())
-        {
-            ModifyConfigValue(bGametypeCaptions_, tset, false);
-        }
-
         // create persistent io console
         this->ioConsole_.reset(new IOConsole());
@@ -201,6 +194,4 @@
             .description("If true, all random actions are different each time you start the game")
             .callback(this, &Core::initRandomNumberGenerator);
-        SetConfigValue(bGametypeCaptions_, true)
-            .description("Set to false if you don't want to use Gametype captions.");
     }
 
Index: code/branches/skybox2/src/libraries/core/Core.h
===================================================================
--- code/branches/skybox2/src/libraries/core/Core.h	(revision 6857)
+++ code/branches/skybox2/src/libraries/core/Core.h	(revision 6858)
@@ -67,7 +67,4 @@
             void setConfigValues();
 
-            inline bool hasGametypeCaptions(void)
-                { return this->bGametypeCaptions_; }
-
             //! Returns the configured language.
             const std::string& getLanguage()
@@ -111,5 +108,4 @@
             std::string                   language_;                   //!< The language
             bool                          bInitRandomNumberGenerator_; //!< If true, srand(time(0)) is called
-            bool                          bGametypeCaptions_;
 
             static Core*                  singletonPtr_s;
Index: code/branches/skybox2/src/modules/designtools/SkyboxGenerator.cc
===================================================================
--- code/branches/skybox2/src/modules/designtools/SkyboxGenerator.cc	(revision 6857)
+++ code/branches/skybox2/src/modules/designtools/SkyboxGenerator.cc	(revision 6858)
@@ -60,4 +60,5 @@
         this->setConfigValues();
         takeScreenshot_ = false;
+        this->captionsRemoved_ = false;
     }
 
@@ -76,4 +77,11 @@
         if( takeScreenshot_ == true )
         {
+            if(!this->captionsRemoved_)
+            {
+                CommandExecutor::execute("setGametypeStatus false");
+                this->captionsRemoved_ = true;
+                return;
+            }
+            
             ControllableEntity* ce = HumanController::getLocalControllerSingleton()->getControllableEntity();
             Camera* camera = ce->getCamera();
@@ -81,4 +89,5 @@
         
             Ogre::RenderWindow* w = GraphicsManager::getInstance().getRenderWindow();
+
 
             switch (iterateOverDirections_) 
@@ -131,8 +140,13 @@
                 camera->getOgreCamera()->setAspectRatio(aspectRatio_);
                 camera->getOgreCamera()->setFOVy(fovy_);
+                iterateOverDirections_++;
+            case 8 :
                 iterateOverDirections_ =0;
                 takeScreenshot_ = false;
                 CommandExecutor::execute("pause");
+                CommandExecutor::execute("setGametypeStatus true");
+                this->captionsRemoved_ = false;
             }
+
         }
     }
Index: code/branches/skybox2/src/modules/designtools/SkyboxGenerator.h
===================================================================
--- code/branches/skybox2/src/modules/designtools/SkyboxGenerator.h	(revision 6857)
+++ code/branches/skybox2/src/modules/designtools/SkyboxGenerator.h	(revision 6858)
@@ -54,4 +54,5 @@
             float aspectRatio_;
             Ogre::Radian fovy_;
+            bool captionsRemoved_;
     };
 }
Index: code/branches/skybox2/src/modules/overlays/hud/GametypeStatus.cc
===================================================================
--- code/branches/skybox2/src/modules/overlays/hud/GametypeStatus.cc	(revision 6857)
+++ code/branches/skybox2/src/modules/overlays/hud/GametypeStatus.cc	(revision 6858)
@@ -30,5 +30,5 @@
 
 #include "util/Convert.h"
-#include "core/Core.h"
+#include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
 #include "infos/GametypeInfo.h"
@@ -39,5 +39,8 @@
 namespace orxonox
 {
-    CreateFactory(GametypeStatus);
+    CreateFactory(GametypeStatus);  
+
+    /*static*/ bool GametypeStatus::noCaption_s = false; 
+    SetConsoleCommand(GametypeStatus, setGametypeStatus, true);
 
     GametypeStatus::GametypeStatus(BaseObject* creator) : OverlayText(creator)
@@ -61,6 +64,9 @@
             ControllableEntity* ce = this->owner_->getControllableEntity();
 
-            if(!Core::getInstance().hasGametypeCaptions()) // No captions are displayed.
+            if(GametypeStatus::noCaption_s) // No captions are displayed.
+            {
+                this->setCaption("");
                 return;
+            }
 
             if (!gtinfo->hasStarted() && !gtinfo->isStartCountdownRunning())
@@ -92,3 +98,15 @@
         this->owner_ = orxonox_cast<PlayerInfo*>(this->getOwner());
     }
+
+    /**
+    @brief
+        Sets whether the gametype status is displayed.
+    @param bValue
+        If true captions are displayed, if false, not.
+    */
+    /*static*/ void GametypeStatus::setGametypeStatus(bool bValue)
+    {
+        GametypeStatus::noCaption_s = !bValue;
+    }
+    
 }
Index: code/branches/skybox2/src/modules/overlays/hud/GametypeStatus.h
===================================================================
--- code/branches/skybox2/src/modules/overlays/hud/GametypeStatus.h	(revision 6857)
+++ code/branches/skybox2/src/modules/overlays/hud/GametypeStatus.h	(revision 6858)
@@ -46,6 +46,10 @@
             virtual void changedOwner();
 
+            static void setGametypeStatus(bool bValue); //!< Toggles whether the gametype status is displayed.
+
         private:
             PlayerInfo* owner_;
+            static bool noCaption_s;
+            
     };
 }